using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Net.NetworkInformation;
using System.Threading;
using System.Diagnostics;

namespace SiteScan
{
    public partial class Form1 : Form
    {
        const int interval = 5;
        const int retry = 1;
        const int pause = 1;
        public Form1()
        {
            InitializeComponent();
            dataGridView1.Rows.Clear();
            dataGridView1.Rows.Add();
            dataGridView1.Rows[0].
                Cells["Address"].Value = "91.84.5.53";
            dataGridView1.Rows[0].
                Cells["Status"].Value = "Not Tested";
            dataGridView1.Rows.Add();
            dataGridView1.Rows[1].
                Cells["Address"].Value = "www.i-programmer.info";
            dataGridView1.Rows[1].
                Cells["Status"].Value = "Not Tested";
            timer1.Enabled = false;
            timer1.Interval = interval * 60 * 1000;
            eventLog1.Log = "SiteStatus";
            eventLog1.Source = "SiteScanner";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1_Tick(timer1, new EventArgs());
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            textBox1.Text += "Update at:" +
                DateTime.Now.ToString() +
                Environment.NewLine;
            textBox1.Refresh();
            foreach (DataGridViewRow row in dataGridView1.Rows)
            {
                if (row.Cells["Address"].Value != null)
                {
                    PingReply reply = DoPing(row.Cells["Address"].Value.ToString(), retry, pause);
                    if (row.Cells["Status"].Value.ToString() != reply.Status.ToString())
                    {
                        eventLog1.WriteEntry(
                            row.Cells["Address"].Value.ToString() +
                               "," + reply.Status.ToString() +
                               "," + reply.RoundtripTime.ToString());
                        row.Cells["Status"].Value = reply.Status.ToString();
                        row.Cells["Time"].Value = reply.RoundtripTime.ToString();
                        dataGridView1.Refresh();
                    }

                
                    Application.DoEvents();

                }
            }
        }



        private PingReply DoPing(string address, int retry, int pause)
        {
            Ping pinger = new Ping();
            PingReply reply = null;
            for (int i = 1; i <= retry; i++)
            {
                reply = pinger.Send(address);
                if (reply.Status == IPStatus.Success) break;
                Thread.Sleep(pause * 1000);


            }
            return reply;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            foreach (DataGridViewRow row in dataGridView1.Rows)
            {
                if (row.Cells["Address"].Value != null)
                {
                    eventLog1.WriteEntry(
                            row.Cells["Address"].Value.ToString() +
                            "," + row.Cells["Status"].Value.ToString() +
                            "," + row.Cells["Time"].Value.ToString(),
                            EventLogEntryType.Information,
                            1);
                }

            }
        }
    }
}